Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_pftinout.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_pftinout.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_pftinout.f90	(revision 257)
@@ -33,5 +33,5 @@
   SUBROUTINE pftinout (npts, dt, adapted, regenerate, &
        neighbours, veget, veget_max, &
-       biomass, ind, age, leaf_frac, npp_longterm, lm_lastyearmax, senescence, &
+       biomass, ind, cn_ind, age, leaf_frac, npp_longterm, lm_lastyearmax, senescence, &
        PFTpresent, everywhere, when_growthinit, need_adjacent, RIP_time, &
        co2_to_bm, &
@@ -66,4 +66,6 @@
     ! density of individuals 1/m**2
     REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)           :: ind
+    ! crownarea of individuals m**2
+    REAL(r_std), DIMENSION(npts,nvm), INTENT(in)              :: cn_ind
     ! mean age (years)
     REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)           :: age
@@ -104,5 +106,5 @@
     REAL(r_std), DIMENSION(npts)                               :: avail
     ! indices
-    INTEGER(i_std)                                             :: i,j
+    INTEGER(i_std)                                             :: i,j,m
     ! total woody vegetation cover
     REAL(r_std), DIMENSION(npts)                               :: sumfrac_wood
@@ -111,4 +113,6 @@
     ! we can introduce this PFT
     LOGICAL, DIMENSION(npts)                                  :: can_introduce
+    ! no real need for dimension(ntps) except for vectorisation
+    REAL(r_std), DIMENSION(npts)                               :: fracnat
 
     ! =========================================================================
@@ -132,16 +136,31 @@
     !
 
-    ! need to know total woody vegetation fraction
-
+    ! 2.1 Only natural part of the grid cell
+    !
+    !SZ bug correction MERGE: need to subtract agricultural area!
+    ! fraction of agricultural surface
+    fracnat(:) = 1.
+    do j = 2,nvm
+       IF ( .NOT. natural(j) ) THEN
+          fracnat(:) = fracnat(:) - veget_max(:,j)
+       ENDIF
+    ENDDO
+
+    !
+    ! 2.2 total woody fpc on grid
+    !
     sumfrac_wood(:) = zero
 
     DO j = 2,nvm
-
-       IF ( tree(j) ) THEN
-
-          sumfrac_wood(:) = sumfrac_wood(:) + veget(:,j)
-
+       !SZ problem here: agriculture, not convinced that this representation of LPJ is correct
+       !if agriculture is present, ind must be recalculated to correspond to the natural density...
+       ! since ind is per grid cell, can be achived by discounting for agricultura fraction
+       IF ( natural(j).AND.tree(j) ) THEN
+          WHERE(fracnat(:).GT.min_stomate)
+                sumfrac_wood(:) = sumfrac_wood(:) + cn_ind(:,j) * ind(:,j) / fracnat(:) & 
+                     * ( 1. - exp( - lm_lastyearmax(:,j) * sla(j) * ext_coeff(j) ) )
+                !lai changed to lm_last
+          ENDWHERE
        ENDIF
-
     ENDDO
 
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate.f90	(revision 257)
@@ -227,10 +227,15 @@
   INTEGER(i_std),ALLOCATABLE,SAVE,DIMENSION(:)  :: nforce
 
+  REAL(r_std),ALLOCATABLE,SAVE,DIMENSION(:)  :: harvest_above_monthly, cflux_prod_monthly
+
+  ! "maximal" coverage fraction of a PFT (LAI -> infinity) on ground 
+  REAL(r_std), ALLOCATABLE,SAVE,DIMENSION(:,:)              :: fpc_max
+
   ! Date and EndOfYear, intialize and update in slowproc
   ! (Now managed in slowproc for land_use)
   ! time step of STOMATE in days
-  REAL(r_std),SAVE                              :: dt_days=0.           ! Time step in days for stomate
+  REAL(r_std),SAVE                              :: dt_days=zero           ! Time step in days for stomate
   ! to check
-  REAL(r_std),SAVE                              :: day_counter=0.       ! count each sechiba (dtradia) time step each day
+  REAL(r_std),SAVE                              :: day_counter=zero       ! count each sechiba (dtradia) time step each day
   ! date (d)
   INTEGER(i_std),SAVE                          :: date=0
@@ -242,4 +247,7 @@
   ! Land cover change flag
   LOGICAL,SAVE                                 :: lcchange=.FALSE.
+  ! Do update of monthly variables ?
+  ! This variable must be .TRUE. once a month
+  LOGICAL, SAVE                                :: EndOfMonth=.FALSE.
   PUBLIC  dt_days, day_counter, date, do_slow, EndOfYear, lcchange
 
@@ -554,9 +562,12 @@
 
     REAL(r_std), DIMENSION(kjpindex)                                   :: vartmp
+    REAL(r_std)      :: net_cflux_prod_monthly_sum   , net_cflux_prod_monthly_tot
+    REAL(r_std)      :: net_harvest_above_monthly_sum, net_harvest_above_monthly_tot
+    REAL(r_std)      :: net_biosp_prod_monthly_sum   , net_biosp_prod_monthly_tot
     !---------------------------------------------------------------------
     ! first of all: store time step in common value
     itime = kjit
 
-    z_soil(0) = 0.
+    z_soil(0) = zero
     z_soil(1:nbdl) = diaglev(1:nbdl)
     DO j=1,nvm
@@ -877,5 +888,5 @@
              ENDIF
 
-             dt_forcesoil = 0.
+             dt_forcesoil = zero
              nparan = nparan+1
              DO WHILE (dt_forcesoil < dt_slow/one_day)
@@ -951,5 +962,5 @@
        l_first_stomate = .FALSE.
        !
-       ! 1.11 retu n
+       ! 1.11 return
        !
        RETURN
@@ -1158,4 +1169,9 @@
     ENDDO
 
+    IF ( day == 1 .AND. sec .LT. dtradia ) THEN
+       EndOfMonth=.TRUE.
+    ELSE
+       EndOfMonth=.FALSE.
+    ENDIF
     !
     ! 5 "daily" variables
@@ -1293,5 +1309,5 @@
 
           CALL StomateLpj &
-               &            (kjpindex, dt_days, EndOfYear, &
+               &            (kjpindex, dt_days, EndOfYear, EndOfMonth, &
                &             neighbours, resolution, &
                &             clay, herbivores, &
@@ -1318,5 +1334,6 @@
                &             t_photo_min, t_photo_opt, t_photo_max,bm_to_litter,&
                &             prod10, prod100, flux10, flux100, veget_cov_max_new,&
-               &             convflux, cflux_prod10, cflux_prod100, harvest_above, lcchange)
+               &             convflux, cflux_prod10, cflux_prod100, harvest_above, lcchange,&
+               &             fpc_max)
 
           !
@@ -1534,12 +1551,15 @@
        !
        co2_flux_monthly(:,:) = co2_flux_monthly(:,:) + co2_flux_daily(:,:)
-       IF ( day == 1 .AND. sec .LT. dtradia ) THEN
+!      Monthly Cumulative fluxes of fluc and harvest
+       harvest_above_monthly(:) = harvest_above_monthly(:) + harvest_above(:)
+       cflux_prod_monthly(:) = cflux_prod_monthly(:) + convflux(:) + cflux_prod10(:) + cflux_prod100(:)
+       IF ( EndOfMonth ) THEN
           IF ( control%ok_stomate ) THEN
-             CALL histwrite (hist_id_stomate, 'CO2FLUX_MONTHLY', itime, &
+             CALL histwrite (hist_id_stomate, 'CO2FLUX', itime, &
                   co2_flux_monthly, kjpindex*nvm, horipft_index)
           ENDIF
 !MM
 ! Si on supprimer le cumul par mois, 
-! il ne faut pas oublié cette modif resolution(:,1)*resolution(:,2)*contfrac(:) 
+! il ne faut pas oublier cette modif resolution(:,1)*resolution(:,2)*contfrac(:) 
           DO j=2, nvm
              co2_flux_monthly(:,j) = co2_flux_monthly(:,j)* &
@@ -1551,15 +1571,37 @@
              DO j=2,nvm
                 net_co2_flux_monthly = net_co2_flux_monthly + &
-                     &  co2_flux_monthly(ji,j)*veget_max(ji,j)
+                     &  co2_flux_monthly(ji,j)*veget_cov_max(ji,j)
              ENDDO
           ENDDO
+!         Total ( land) Cumulative fluxes of fluc and harvest
+          net_cflux_prod_monthly_sum=&
+              &  SUM(cflux_prod_monthly(:)*resolution(:,1)*resolution(:,2)*contfrac(:))*1e-15
+          CALL reduce_sum(net_cflux_prod_monthly_sum,net_cflux_prod_monthly_tot)
+          CALL bcast(net_cflux_prod_monthly_tot)
+
+          net_harvest_above_monthly_sum=&
+             &   SUM(harvest_above_monthly(:)*resolution(:,1)*resolution(:,2)*contfrac(:))*1e-15
+          CALL reduce_sum(net_harvest_above_monthly_sum,net_harvest_above_monthly_tot)
+          CALL bcast(net_harvest_above_monthly_tot)
+
           net_co2_flux_monthly = net_co2_flux_monthly*1e-15
-          WRITE(numout,*) 'net_co2_flux_monthly (Peta gC/month)  = ',net_co2_flux_monthly
-
           CALL reduce_sum(net_co2_flux_monthly,net_co2_flux_monthly_sum)
-          IF ( control%ok_stomate ) THEN
-             CALL histwrite (hist_id_stomate, 'CO2FLUX_MONTHLY_SUM', itime, &
-                  (/ net_co2_flux_monthly /), 1, (/ 1 /) )
-          ENDIF
+          CALL bcast(net_co2_flux_monthly_sum)
+
+          WRITE(numout,9010) 'GLOBAL net_cflux_prod_monthly    (Peta gC/month)  = ',net_cflux_prod_monthly_tot
+          WRITE(numout,9010) 'GLOBAL net_harvest_above_monthly (Peta gC/month)  = ',net_harvest_above_monthly_tot
+          WRITE(numout,9010) 'GLOBAL net_co2_flux_monthly      (Peta gC/month)  = ',net_co2_flux_monthly_sum
+
+!         Calculation of net biospheric production
+          net_biosp_prod_monthly_tot =  &
+             &    ( net_co2_flux_monthly_sum + net_cflux_prod_monthly_tot + net_harvest_above_monthly_tot )
+          WRITE(numout,9010) 'GLOBAL net_biosp_prod_monthly    (Peta gC/month)  = ',net_biosp_prod_monthly_tot
+
+9010  FORMAT(A52,F17.14)
+!!$          IF ( control%ok_stomate ) THEN
+!!$             vartmp(:)=net_co2_flux_monthly_sum
+!!$             CALL histwrite (hist_id_stomate, 'CO2FLUX_MONTHLY_SUM', itime, &
+!!$                  vartmp, kjpindex, hori_index )
+!!$          ENDIF
 !!$          IF (is_root_prc) THEN
 !!$             OPEN( unit=39,              &
@@ -1579,4 +1621,6 @@
 !!$          ENDIF
           co2_flux_monthly(:,:) = zero
+          harvest_above_monthly(:) = zero
+          cflux_prod_monthly(:)    = zero
        ENDIF
        !
@@ -1599,15 +1643,4 @@
 
     ENDIF  ! daily processes?
-    ! CO2FLUX Daily values are saved each dtradia,
-    ! then the value is wrong for the first day without restart.
-    IF ( hist_id > 0 ) THEN
-       CALL histwrite (hist_id, 'CO2FLUX', itime, &
-            co2_flux_daily, kjpindex*nvm, horipft_index)
-    ENDIF
-    IF ( hist2_id > 0 ) THEN
-       CALL histwrite (hist2_id, 'CO2FLUX', itime, &
-            co2_flux_daily, kjpindex*nvm, horipft_index)
-    ENDIF
-
     !
     ! 7 Outputs from Stomate
@@ -1907,4 +1940,8 @@
     ALLOCATE(co2_flux_monthly(kjpindex,nvm),stat=ier)
     l_error = l_error .OR. (ier /= 0)
+    ALLOCATE (cflux_prod_monthly(kjpindex), stat=ier)
+    l_error = l_error .OR. (ier.NE.0)
+    ALLOCATE (harvest_above_monthly(kjpindex), stat=ier)
+    l_error = l_error .OR. (ier.NE.0)
     ALLOCATE(bm_to_litter(kjpindex,nvm,nparts),stat=ier)
     l_error = l_error .OR. (ier /= 0)
@@ -1955,4 +1992,7 @@
     l_error = l_error .OR. (ier.NE.0)
     !
+    ALLOCATE (fpc_max(kjpindex,nvm), stat=ier)
+    l_error = l_error .OR. (ier.NE.0)
+    !
     IF (l_error) THEN
        STOP 'stomate_init: error in memory allocation'
@@ -2028,4 +2068,14 @@
     WRITE(numout,*) &
          &  'expansion across a grid cell is treated: ',treat_expansion
+
+    !Config Key  = LPJ_GAP_CONST_MORT
+    !Config Desc = prescribe mortality if not using DGVM?
+    !Config Def  = y
+    !Config Help = set to TRUE if constant mortality is to be activated
+    !              ignored if DGVM=true!
+    !
+    lpj_gap_const_mort=.TRUE.
+    CALL getin('LPJ_GAP_CONST_MORT', lpj_gap_const_mort)
+    WRITE(numout,*) 'LPJ GAP: constant mortality:', lpj_gap_const_mort
 
     !Config  Key  = HARVEST_AGRI
@@ -2046,5 +2096,9 @@
     co2_flux_daily(:,:) = zero
     co2_flux_monthly(:,:) = zero
-
+    cflux_prod_monthly(:) = zero
+    harvest_above_monthly(:) = zero
+    control_moist_daily(:,:) = zero
+    control_temp_daily(:,:) = zero
+    soilcarbon_input_daily(:,:,:) = zero
 
     ! initialisation of land cover change variables
@@ -2056,4 +2110,6 @@
     cflux_prod10(:) = zero
     cflux_prod100(:)= zero
+
+    fpc_max(:,:)=zero
     !--------------------------
   END SUBROUTINE stomate_init
@@ -2141,4 +2197,6 @@
     IF (ALLOCATED(co2_flux_daily)) DEALLOCATE(co2_flux_daily)
     IF (ALLOCATED(co2_flux_monthly)) DEALLOCATE(co2_flux_monthly)
+    IF (ALLOCATED(harvest_above_monthly)) DEALLOCATE (harvest_above_monthly)
+    IF (ALLOCATED(cflux_prod_monthly)) DEALLOCATE (cflux_prod_monthly)
     IF (ALLOCATED(bm_to_litter)) DEALLOCATE(bm_to_litter)
     IF (ALLOCATED(bm_to_littercalc)) DEALLOCATE(bm_to_littercalc)
@@ -2203,4 +2261,6 @@
     IF ( ALLOCATED (control_temp_daily)) DEALLOCATE (control_temp_daily)
     IF ( ALLOCATED (control_moist_daily)) DEALLOCATE (control_moist_daily)
+
+    IF ( ALLOCATED (fpc_max)) DEALLOCATE (fpc_max)
 
     ! 2. reset l_first
@@ -2265,5 +2325,5 @@
     !-
     ! dummy time step, must be zero
-    REAL(r_std),PARAMETER                        :: dt_0 = 0.
+    REAL(r_std),PARAMETER                        :: dt_0 = zero
     REAL(r_std),DIMENSION(kjpindex,nvm)          :: vcmax
     REAL(r_std),DIMENSION(kjpindex,nvm)          :: vjmax
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_alloc.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_alloc.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_alloc.f90	(revision 257)
@@ -162,5 +162,5 @@
        ! 1.1.1 soil levels
 
-       z_soil(0) = 0.
+       z_soil(0) = zero
        z_soil(1:nbdl) = diaglev(1:nbdl)
 
@@ -202,6 +202,6 @@
     !
 
-    f_alloc(:,:,:) = 0.0
-    f_alloc(:,:,icarbres) = 1.0
+    f_alloc(:,:,:) = zero
+    f_alloc(:,:,icarbres) = un
     !
     ! 1.3 Convolution of the temperature and humidity profiles with some kind of profile
@@ -212,5 +212,5 @@
 
     ! 1.3.1.1 rpc is an integration constant such that the integral of the root profile is 1.
-    rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_nitrogen ) )
+    rpc(:) = un / ( un - EXP( -z_soil(nbdl) / z_nitrogen ) )
 
     ! 1.3.1.2 integrate over the nbdl levels
@@ -229,9 +229,9 @@
 
     ! 1.3.2.1 rpc is an integration constant such that the integral of the root profile is 1.
-    rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_nitrogen ) )
+    rpc(:) = un / ( un - EXP( -z_soil(nbdl) / z_nitrogen ) )
 
     ! 1.3.2.2 integrate over the nbdl levels
 
-    h_nitrogen(:) = 0.0
+    h_nitrogen(:) = zero
 
     DO l = 1, nbdl
@@ -251,6 +251,6 @@
     ! mean LAI on natural part
 
-    natveg_tot(:) = 0.0
-    lai_nat(:) = 0.0
+    natveg_tot(:) = zero
+    lai_nat(:) = zero
 
     DO j = 2, nvm
@@ -259,5 +259,5 @@
           veget_max_nat(:,j) = veget_max(:,j)
        ELSE
-          veget_max_nat(:,j) = 0.0
+          veget_max_nat(:,j) = zero
        ENDIF
 
@@ -314,5 +314,5 @@
        !             3/ must be at the beginning of the growing season
 
-       WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. & 
+       WHERE ( ( biomass(:,j,ileaf) .GT. zero ) .AND. & 
             ( .NOT. senescence(:,j) ) .AND. &
             ( lai(:,j) .LT. lai_happy(j) ) .AND. &
@@ -337,5 +337,5 @@
        ELSEWHERE
 
-          transloc_leaf(:) = 0.0
+          transloc_leaf(:) = zero
 
        ENDWHERE
@@ -468,10 +468,10 @@
           ! leaf allocation
 
-          LtoLSR(:) = 1. - RtoLSR(:) - StoLSR(:)
+          LtoLSR(:) = un - RtoLSR(:) - StoLSR(:)
           LtoLSR(:) = MAX( min_LtoLSR, MIN( max_LtoLSR, LtoLSR(:) ) )
 
           ! roots: the rest
 
-          RtoLSR(:) = 1. - LtoLSR(:) - StoLSR(:)
+          RtoLSR(:) = un - LtoLSR(:) - StoLSR(:)
 
        ENDWHERE
@@ -483,5 +483,5 @@
           StoLSR(:) = StoLSR(:) + LtoLSR(:)
 
-          LtoLSR(:) = 0.0
+          LtoLSR(:) = zero
 
        ENDWHERE
@@ -514,7 +514,7 @@
 
                 IF ( ( biomass(i,j,icarbres)*sla(j) ) .LT. 2*lai_max(j) ) THEN
-                   carb_rescale(i) = 1. / ( 1. + ecureuil(j) * ( LtoLSR(i) + RtoLSR(i) ) )
+                   carb_rescale(i) = un / ( un + ecureuil(j) * ( LtoLSR(i) + RtoLSR(i) ) )
                 ELSE
-                   carb_rescale(i) = 1.
+                   carb_rescale(i) = un
                 ENDIF
 
@@ -522,7 +522,7 @@
 
                 f_alloc(i,j,isapabove) = StoLSR(i) * alloc_sap_above(i) * &
-                     ( 1. - f_alloc(i,j,ifruit) ) * carb_rescale(i)
-                f_alloc(i,j,isapbelow) = StoLSR(i) * ( 1. - alloc_sap_above(i) ) * &
-                     ( 1. - f_alloc(i,j,ifruit) ) * carb_rescale(i)
+                     ( un - f_alloc(i,j,ifruit) ) * carb_rescale(i)
+                f_alloc(i,j,isapbelow) = StoLSR(i) * ( un - alloc_sap_above(i) ) * &
+                     ( un - f_alloc(i,j,ifruit) ) * carb_rescale(i)
 
                 f_alloc(i,j,iroot) = RtoLSR(i) * ( 1.-f_alloc(i,j,ifruit) ) * carb_rescale(i)
@@ -530,5 +530,5 @@
                 ! this is equivalent to:
                 ! reserve alloc = ecureuil*(LtoLSR+StoLSR)*(1-fruit_alloc)*carb_rescale
-                f_alloc(i,j,icarbres) = ( 1. - carb_rescale(i) ) * ( 1.-f_alloc(i,j,ifruit) )
+                f_alloc(i,j,icarbres) = ( un - carb_rescale(i) ) * ( 1.-f_alloc(i,j,ifruit) )
 
              ENDIF  ! senescent?
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_data.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_data.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_data.f90	(revision 257)
@@ -156,5 +156,42 @@
        ! Oct 2010 : replaced by values given by N.Viovy
 
-       IF ( bavard .GE. 1 ) WRITE(numout,*) '       specific leaf area (m**2/gC):', sla(j) !, 12./leaflife(j)
+       ! includes conversion from 
+       !!       sla(j) = 2. * 1e-4 * EXP(5.615 - 0.46 * log(12./leaflife_tab(j)))
+
+       IF ( leaf_tab(j) .EQ. 2 ) THEN
+
+          ! needle leaved tree
+          sla(j) = 2. * ( 10. ** ( 2.29 - 0.4 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
+
+       ELSE
+
+          ! broad leaved tree or grass (Reich et al 1992)
+          sla(j) = 2. * ( 10. ** ( 2.41 - 0.38 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
+
+       ENDIF
+
+!!$      IF ( leaf_tab(j) .EQ. 1 ) THEN
+!!$
+!!$        ! broad leaved tree
+!!$
+!!$        sla(j) = 2. * ( 10. ** ( 2.41 - 0.38 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
+!!$
+!!$      ELSE
+!!$
+!!$        ! needle leaved or grass (Reich et al 1992)
+!!$
+!!$        sla(j) = 2. * ( 10. ** ( 2.29 - 0.4 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
+!!$
+!!$      ENDIF
+!!$
+!!$      IF ( ( leaf_tab(j) .EQ. 2 ) .AND. ( pheno_type_tab(j) .EQ. 2 ) ) THEN
+!!$
+!!$        ! summergreen needle leaf
+!!$
+!!$        sla(j) = 1.25 * sla(j)
+!!$
+!!$      ENDIF
+
+       IF ( bavard .GE. 1 ) WRITE(numout,*) '       specific leaf area (m**2/gC):', sla(j), 12./leaflife_tab(j)
 
        !
@@ -175,5 +212,5 @@
              bm_sapl(j,icarbres) = bm_sapl_carbres * bm_sapl(j,ileaf)
           ELSE
-             bm_sapl(j,icarbres) = 0.0
+             bm_sapl(j,icarbres) = zero
           ENDIF
 
@@ -203,9 +240,9 @@
           bm_sapl(j,icarbres) = init_sapl_mass_carbres *bm_sapl(j,ileaf)
 
-          bm_sapl(j,isapabove) = 0.
-          bm_sapl(j,isapbelow) = 0.
-
-          bm_sapl(j,iheartabove) = 0.
-          bm_sapl(j,iheartbelow) = 0.
+          bm_sapl(j,isapabove) = zero
+          bm_sapl(j,isapbelow) = zero
+
+          bm_sapl(j,iheartabove) = zero
+          bm_sapl(j,iheartbelow) = zero
 
        ENDIF
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_lcchange.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_lcchange.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_lcchange.f90	(revision 257)
@@ -139,5 +139,5 @@
 
     ! Turnover rates (gC/(m**2 of ground)/day)
-    REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(out)               :: turnover_daily
+    REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(inout)               :: turnover_daily
 
     ! 0.4 local
@@ -207,14 +207,14 @@
                    cn_ind(i,j) = cn_sapl(j)
                 ELSE
-                   cn_ind(i,j)=1.0
+                   cn_ind(i,j) = un
                 ENDIF
                 ind(i,j)= delta_veg(j) / cn_ind(i,j)
                 PFTpresent(i,j) = .TRUE.
-                everywhere(i,j) = 1.
+                everywhere(i,j) = un
                 senescence(i,j) = .FALSE.
                 age(i,j) = 0.
 
                 when_growthinit(i,j) = large_value
-                leaf_frac(i,j,1) = 1.0
+                leaf_frac(i,j,1) = un
                 npp_longterm(i,j) = 10.
                 lm_lastyearmax(i,j) = bm_sapl(j,ileaf) * ind(i,j)
@@ -321,8 +321,8 @@
        flux100(i,1)      = 0.01 * prod100(i,0)
        prod100(i,1)      = prod100(i,0)
-!MM=>          IF (prod100(i,1).LT.1.0) prod100(i,1) = 0.0
+!MM=>          IF (prod100(i,1).LT.1.0) prod100(i,1) = zero
 !MM=>stomate_lpj.f90       prod100_total(i)  = prod100_total(i) + prod100(i,1)
-       prod10(i,0)        = 0.0
-       prod100(i,0)       = 0.0 
+       prod10(i,0)        = zero
+       prod100(i,0)       = zero
 
     ENDDO  ! End loop on npts
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_litter.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_litter.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/stomate_litter.f90	(revision 257)
@@ -185,5 +185,5 @@
        !
 
-       z_soil(0) = 0.
+       z_soil(0) = zero
        z_soil(1:nbdl) = diaglev(1:nbdl)
 
@@ -441,5 +441,5 @@
 
     ! 4.2.1 rpc is an integration constant such that the integral of the root profile is 1.
-    rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_decomp ) )
+    rpc(:) = un / ( un - EXP( -z_soil(nbdl) / z_decomp ) )
 
     ! 4.2.2 integrate over the nbdl levels
@@ -473,5 +473,5 @@
 
     ! 5.2.1 rpc is an integration constant such that the integral of the root profile is 1.
-    rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_decomp ) )
+    rpc(:) = un / ( un - EXP( -z_soil(nbdl) / z_decomp ) )
 
     ! 5.2.2 integrate over the nbdl levels
@@ -514,5 +514,5 @@
           ! to avoid a multiple (for ibelow and iabove) modification of dead_leaves,
           ! we do this test to do this calcul only ones in 1,nlev loop
-          if (l == iabove)  dead_leaves(:,m,istructural) = dead_leaves(:,m,istructural) * ( 1. - fd(:) )
+          if (l == iabove)  dead_leaves(:,m,istructural) = dead_leaves(:,m,istructural) * ( un - fd(:) )
 
           ! 6.1.3 non-lignin fraction of structural litter goes into
